#!/usr/bin/perl
##################################################################
# Autoresponder and Mailing List Manager                           #
# Version 4.1 Lite                                                 #
# Copyright 2005-2020                                              #
# A free script from:   http://free-software.biz/amlmlite.html     #
##################################################################
#                          COPYRIGHT NOTICE                        #
#                                                                  #
# Copyright 2005-2020 http://free-software.biz/amlmpro.html        #
#                                                                  #
#          Please read license.htm or license.txt file             #
#             before proceeding with installation.                 #
#                                                                  #
# You are granted permission to use this Software as long as:      #
#                                                                  #
#  - You do not modify the Software in any way                     #
#  - You do not modify this agreement in any way                   #
#  - You do not claim ownership of any ammended files              #
#  - You do not remove any copyright notices                       #
#  - You do not change/remove the 'Autoresponder and Mailing List  #
#    Manager 4.1 Lite' name in any of the source files,            #
#    generated URLs and outgoing emails                            #
#                                                                  #
# Modifying, selling the code for this software over the Internet  #
# or in any other medium is forbidden.                             #
#                                                                  #
# If you really need to remove the return links, go to             #
# http://free-software.biz/amlmpro.html                            #
# and upgrade to the Pro version                                   #
#                                                                  #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,  #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES  #
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND         #
# NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT     #
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,     #
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     #
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR    #
# OTHER DEALINGS IN THE SOFTWARE.                                  #
#                                                                  #
##################################################################

require 'conf.cgi';
&par_prepare;
$shabl_page_install="$SHABL_DIR/install.html";
local %func;
%func=(1=>1, 2=>1,3=>1,4=>1);
&print_all;
sub print_all{
	&printheader;
	$PAR{step}=1 unless $PAR{step};
	my $page=new hfparser(
		DATA=>$shabl_page_install
	);
	$page->SplitData("<!--START-->","<!--END-->");
	my $what;
	$what = &print_step1 if exists $func{$PAR{step}};
	$what = "Do not change the URL!!!" unless exists $func{$PAR{step}};
	$page->replaceINSIDE($what);
	$page->ParseData;
	$page->print;
}
sub print_step1{
	my $page=new hfparser(
		DATA=>$shabl_page_install
	);
	if ($PAR{step}>1){
		if ($PAR{step}==2){
			unless($page->is_error){
				return &print_step2;
			}
		}else{
			return &print_step2;
		}
	}
	$page->set_input("licence",{size=>25});
	$page->SplitData("<!--START1-->","<!--END1-->");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
sub print_step2{
	my $page=new hfparser(
		DATA=>$shabl_page_install,
		ERROR_AFTER_INPUT=>0
	);
	if ($PAR{step}>2){
		if ($PAR{step}==3){
			unless($PAR{prefix}){
				$page->set_error("prefix","Database prefix is required");
			}else{
				unless ($PAR{prefix}=~/^[a-z][a-z_0-9]{0,3}$/){
					$page->set_error("prefix","Database prefix is incorrect it must be 1-4 chars a-z or '_'");					
				}

			}
			unless($page->is_error){
				unless($db = DBI->connect("DBI:mysql:database=$PAR{db};host=$PAR{host}",$PAR{user},$PAR{password})){
					$page->set_error("GLOBAL","We are not connected to database $PAR{db}: <BR> Error: $DBI::err : $DBI::errstr ");
					$page->set_error("host"," ");
					$page->set_error("db"," ");
					$page->set_error("user"," ");
					$page->set_error("password"," ");				
				}
			}
			
			unless($page->is_error){
				my $out;
				$out="_us:$PAR{user};_db:$PAR{db};_pass:$PAR{password};_pref:$PAR{prefix};_host:$PAR{host}";
				open (OUT,">$c_file") || die "Can not write to file $c_file - $!";
				print OUT fs($out,$cfg_psd x ceil(length($out)/length($cfg_psd)));
				close(OUT);
				my $query;
				while(<DATA>){
					next if /^#/;
					$query.=$_;
				}
				$query=~s/swd_/$PAR{prefix}/g;
				multiSQL($query);
				return &print_step3;
			}
		}else{
			return &print_step3;
		}
	}
	$page->SplitData("<!--START2-->","<!--END2-->");
	$page->deleteBEFORE_AFTER();
	$page->set_def("host","localhost");
	$page->set_def("prefix","swd_");
	$page->set_input("prefix",{maxlength=>4,size=>4});
	$page->ParseData;
	return $page->as_string;
}
########################
sub print_step3{
	&db_prepare;
	my $page=new hfparser(
		DATA=>$shabl_page_install,
	);
	if ($PAR{step}>3){
		if ($PAR{step}==4){
			if ($PAR{newpass1} && $PAR{newpass2}){
				$page->set_error("newpass1","Not equal") if ($PAR{newpass1} ne $PAR{newpass2});
				$page->set_error("newpass2","Not equal") if ($PAR{newpass1} ne $PAR{newpass2});
			}else{
				$page->set_error("newpass1","Required") unless defined $PAR{newpass1};
				$page->set_error("newpass2","Required") unless defined $PAR{newpass2};			
			}
			unless($page->is_error){
				save_config(0,"adminpwd",$PAR{newpass1});
				save_config(0,"licence",$PAR{licence});
				return &print_step4;
			}
		}else{
			return &print_step4;
		}
	}
	$page->SplitData("<!--START3-->","<!--END3-->");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}
##################
sub print_step4{
	&db_prepare;
	my $page=new hfparser(
		DATA=>$shabl_page_install,
	);
	$page->SplitData("<!--START4-->","<!--END4-->");
	$page->deleteBEFORE_AFTER();
	$page->ParseData;
	return $page->as_string;
}

__DATA__
DROP TABLE IF EXISTS swd_account;
CREATE TABLE swd_account (
  pk_account int(11) default NULL auto_increment,
  name char(16) NOT NULL default '                ',
  isact tinyint(4) NOT NULL default '1',
  PRIMARY KEY (pk_account)
) TYPE=MyISAM;
INSERT INTO swd_account VALUES (1, 'sample', '0');
DROP TABLE IF EXISTS swd_attach;
CREATE TABLE swd_attach (
  pk_attach int(11) default NULL auto_increment,
  filename varchar(80) NOT NULL default '                                                                                ',
  data longblob NOT NULL,
  fk_mess int(11) NOT NULL default '0',
  len int(11) NOT NULL default '0',
  PRIMARY KEY (pk_attach)
) TYPE=MyISAM;
DROP TABLE IF EXISTS swd_conf;
CREATE TABLE swd_conf (
  pk_conf varchar(30) NOT NULL default '                              ',
  conf_value text NOT NULL,
  discr text,
  fk_account int(11) NOT NULL default '0',
  KEY pk_conf(pk_conf),
  PRIMARY KEY (pk_conf,fk_account)
) TYPE=MyISAM;
INSERT INTO swd_conf VALUES ('adminpwd', '',  NULL, 0);
INSERT INTO swd_conf VALUES ('licence', '',  NULL, 0);
INSERT INTO swd_conf VALUES ('serverurl', '',  NULL, 0);
INSERT INTO swd_conf VALUES ('defname', 'Friend',  NULL, 1);
INSERT INTO swd_conf VALUES ('subscribeemail', 'subscribe@myhost.net',  NULL, 1);
INSERT INTO swd_conf VALUES ('pop3server', 'pop3.novere.org',  NULL, 1);
INSERT INTO swd_conf VALUES ('pop3user', 'johndoe',  NULL, 1);
INSERT INTO swd_conf VALUES ('pop3pass', 'doejohn',  NULL, 1);
INSERT INTO swd_conf VALUES ('pop3port', '110',  NULL, 1);
INSERT INTO swd_conf VALUES ('fromname', 'AMLM Lite User',  NULL, 1);
INSERT INTO swd_conf VALUES ('fromemail', 'novere@mail.com',  NULL, 1);
INSERT INTO swd_conf VALUES ('isaddunsubscrlink', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('isnotifsubscr', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('isnotifunsubscr', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('isdoi', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('doiconfurl', 'http://free-software.biz/amlmpro.html/',  NULL, 1);
INSERT INTO swd_conf VALUES ('ispop3', '',  NULL, 1);
INSERT INTO swd_conf VALUES ('redirsub', 'http://free-software.biz/amlmpro.html',  NULL, 1);
INSERT INTO swd_conf VALUES ('redirrem', 'http://free-software.biz/amlmpro.html',  NULL, 1);
INSERT INTO swd_conf VALUES ('PID', '0',  NULL, 0);
INSERT INTO swd_conf VALUES ('timebroadcast', '1038684974',  NULL, 0);
INSERT INTO swd_conf VALUES ('sendmail', '/usr/sbin/sendmail',  NULL, 0);
INSERT INTO swd_conf VALUES ('modsend', 'sendmail',  NULL, 0);
INSERT INTO swd_conf VALUES ('smtp', 'localhost',  NULL, 0);
INSERT INTO swd_conf VALUES ('adminname', 'Admin Name',  NULL, 0);
INSERT INTO swd_conf VALUES ('adminemail', 'your-email@yourhost.com',  NULL, 0);
INSERT INTO swd_conf VALUES ('statbyemail', 'on',  NULL, 0);
INSERT INTO swd_conf VALUES ('enablelog', 'on',  NULL, 0);
INSERT INTO swd_conf VALUES ('sendsubscr', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('sendunsubscr', 'on',  NULL, 1);
INSERT INTO swd_conf VALUES ('maxlim', '0',  NULL, 0);
INSERT INTO swd_conf VALUES ('timecorr', '+00:00',  NULL, 0);
DROP TABLE IF EXISTS swd_doi;
CREATE TABLE swd_doi (
  pk_doi int(11) default NULL auto_increment,
  ran char(10) NOT NULL default '          ',
  PRIMARY KEY (pk_doi)
) TYPE=MyISAM;
DROP TABLE IF EXISTS swd_doiaccounts;
CREATE TABLE swd_doiaccounts (
  fk_doi int(11) NOT NULL default '0',
  fk_account int(11) NOT NULL default '0',
  fk_user int(11) NOT NULL default '0',
  PRIMARY KEY (fk_doi,fk_account),
  KEY fk_user(fk_user)
) TYPE=MyISAM;
INSERT INTO swd_doiaccounts VALUES (5, 1, 7);
INSERT INTO swd_doiaccounts VALUES (6, 1, 9);
DROP TABLE IF EXISTS swd_doppar;
CREATE TABLE swd_doppar (
  fk_fields int(11) NOT NULL default '0',
  fk_user int(11) NOT NULL default '0',
  value text,
  PRIMARY KEY (fk_fields,fk_user)
) TYPE=MyISAM;
INSERT INTO swd_doppar VALUES (1, 12, 'USA');
INSERT INTO swd_doppar VALUES (2, 12, '54323');
INSERT INTO swd_doppar VALUES (3, 12, 'Nover Str., Apt 22');
INSERT INTO swd_doppar VALUES (4, 12, 'sport');
DROP TABLE IF EXISTS swd_fields;
CREATE TABLE swd_fields (
  pk_fields int(11) default NULL auto_increment,
  fieldname varchar(40) NOT NULL default '                                        ',
  fk_account int(11) NOT NULL default '0',
  is_req int(11) NOT NULL default '0',
  rang tinyint(4) NOT NULL default '1',
  type enum('text','textarea') NOT NULL default 'text',
  PRIMARY KEY (pk_fields)
) TYPE=MyISAM;
INSERT INTO swd_fields VALUES (1, 'Country', 1, 1, '1', 'text');
INSERT INTO swd_fields VALUES (2, 'Zip', 1, 0, '2', 'text');
INSERT INTO swd_fields VALUES (3, 'Address', 1, 0, '3', 'textarea');
INSERT INTO swd_fields VALUES (4, 'Hobby', 1, 0, '4', 'textarea');
DROP TABLE IF EXISTS swd_log;
CREATE TABLE swd_log (
  pk_log int(11) default NULL auto_increment,
  date datetime NOT NULL default '0000-00-00 00:00:00',
  log text,
  PRIMARY KEY (pk_log)
) TYPE=MyISAM;
DROP TABLE IF EXISTS swd_mess;
CREATE TABLE swd_mess (
  pk_mess int(11) default NULL auto_increment,
  fk_account int(11) NOT NULL default '0',
  subject varchar(100) NOT NULL default '                                                                                                    ',
  mess text NOT NULL,
  type enum('text','html') NOT NULL default 'text',
  typesend enum('manual','sent','auto','senddat','subscribe','unsubscribe') NOT NULL default 'manual',
  days int(11) default NULL,
  senddat date default NULL,
  sent int(11) default '0',
  datesend timestamp(14) ,
  PRIMARY KEY (pk_mess),
  KEY typesend(typesend)
) TYPE=MyISAM;
INSERT INTO swd_mess VALUES (1, 1, 'Sample massage 1', 'This is a sample massage in TEXT format.', 'text', 'manual', 0,  NULL, 0, 20021128210452);
INSERT INTO swd_mess VALUES (2, 1, 'Sequential message 1 for [FULLNAME]', 'Test message in <B>HTML</B> format wich will sent to all active users after 2 days after registration\r\n[ADD1] - will add user country', 'html', 'auto', 2,  NULL, 1, 20021130123808);
INSERT INTO swd_mess VALUES (3, 1, 'Subscribe message', 'Your message', 'text', 'subscribe', 0,  NULL, 0, 20021202234245);
INSERT INTO swd_mess VALUES (4, 1, 'Unsubscribe message', 'Your message', 'text', 'unsubscribe', 0,  NULL, 0, 20021202234251);
DROP TABLE IF EXISTS swd_ses;
CREATE TABLE swd_ses (
  pk_ses int(11) default NULL auto_increment,
  ran varchar(25) NOT NULL default '0',
  date datetime default NULL,
  host varchar(14) NOT NULL default '              ',
  PRIMARY KEY (pk_ses)
) TYPE=MyISAM;
DROP TABLE IF EXISTS swd_tosend;
CREATE TABLE swd_tosend (
  fk_mess int(11) NOT NULL default '0',
  fk_user int(11) NOT NULL default '0',
  PRIMARY KEY (fk_mess,fk_user)
) TYPE=MyISAM;
DROP TABLE IF EXISTS swd_user;
CREATE TABLE swd_user (
  pk_user int(11) default NULL auto_increment,
  fk_account int(11) NOT NULL default '0',
  email varchar(40) NOT NULL default '                                                                                ',
  name varchar(40) default NULL,
  isact tinyint(4) NOT NULL default '1',
  datereg date default NULL,
  days tinyint(4) default '0',
  datelastsend date default NULL,
  messlastsend int(11) default NULL,
  countsend int(11) NOT NULL default '0',
  undelivered tinyint(4) default NULL,
  PRIMARY KEY (pk_user),
  KEY fk_account(fk_account,email,isact),
  KEY email(email)
) TYPE=MyISAM;
INSERT INTO swd_user VALUES (12, 1, 'test@nower.org', 'Test User', '1', '2002-12-08', '0',  NULL,  NULL, 0,  NULL);

